//#############################
//# TESTPROGRAMM fr COACH2.2 #
//#############################
//Vor dem Start serielle Verbindung herstellen und 
//ein Hyperterminal mit 115200Baud, 8 Datenbits und einem Stop-Bit ffnen.
//Das Programm auf dem Vehikel kommuniziert mit dem Benutzer ber das Hyperterminal.

//Hier wird der Antrieb getestet.
//Folgen Sie den Anweisungen am Hyperterminal.

#include <avr/io.h>

#include "CoachBASIS.h"
#include "Coach.h"

#include "AnzeigeBASIS.h"
#include "Anzeige.h"

#include "TasterBASIS.h"
#include "Taster.h"

#include "RS232BASIS.h"
#include "RS232.h"

#include "MotorServoBASIS.h"
#include "MotorServo.h"

#include "DrehgeberBASIS.h"
#include "Drehgeber.h"

#include "ZyklusBASIS.h"
#include "Zyklus.h"

#include "SensorBASIS.h"
#include "Sensor.h"

#include "FunkBASIS.h"
#include "Funk.h"


Coach        coach;
Anzeige      anzeige;
Taster       taster;
RS232        rs232;
MotorServo   motorservo;
Drehgeber    drehgeber;
Zyklus       zyklus;
Sensor       sensor;
Funk         funk;

int main(void)
{
    unsigned long pause;
    char* text;

    coach.start();
    anzeige.start();
    taster.start();
    rs232.start();
    motorservo.start();
    drehgeber.start();
    zyklus.start();
    sensor.start();

    funk.start();     // Initialisiere das Funkmodul mit den Einstellungen fr COACH

    rs232.sendeText("\n\rDieses Programm dient dazu, das Funkmodul zu testen.\n\r");

    zyklus.setzeMaxZaehler(50); //50 Zyklen (0..49), bis wieder von vorn gezaehlt wird.
    while(true)
	{
        for(pause = 0;pause<5000000;pause++);
        rs232.sendeText("Geben Sie eine Skriptzeile ein (Quittieren mit #):\n\r"); 
        rs232.sendeText("Beispiel:ABABBCCA;\n\r"); 
        text = rs232.holeText(true); 
        rs232.sendeText("Es wird nun folgender Text per Funk gesendet:\n\r+++"); 
        rs232.sendeText(text); 
        rs232.sendeText("+++\n\r"); 
        rs232.sendeText("Das Vehikel zeigt an, wenn es bereit ist,\n\r"); 
        rs232.sendeText("das nchste Skript zu verarbeiten.\n\r"); 


        funk.sendeText(text);

        //Auf Rcksendung des Skripts warten:
        text = funk.empfangeText();
        rs232.sendeText("Das Vehikel hat folgendes empfangen:\n\r+++"); 
        rs232.sendeText(text); 
        rs232.sendeText("+++\n\r"); 

        //Auf Abschlu der Abarbeitung des Skripts warten:
        while(text[0]!='?')
        {
            text = funk.empfangeText();
            rs232.sendeText(text); 
            rs232.sendeText("\r"); 
        }
	}

    funk.stop();
    sensor.stop();
    zyklus.stop();
    drehgeber.stop();
    motorservo.stop();
    rs232.stop();
    taster.stop();
    anzeige.stop();
    coach.stop();

	return 0;
}
