#define RINGMAX 10

class Sensor : public CoachBASIS, SensorBASIS
{
	private:
        int16_t wert;
        uint8_t  akku;
        uint16_t ringspeicher[RINGMAX];
	    uint8_t index;
	public:
		void start()
		{
            for(index=0;index<RINGMAX;index++)
                ringspeicher[index]=0;
            wert=0;
            akku=0;
            index=0;
             

			ADCSRA = (1<<ADEN) | (1<<ADSC) | (1<<ADATE) | (0<<ADIF) | (0<<ADIE) | (1<<ADPS2) | (1<<ADPS1) | (0<<ADPS0);

		    //Freilaufmode auswhlen:
			SFIOR &= 255 - ((1<<ADTS2) | (1<<ADTS1) | (1<<ADTS0));

		    //AD0 / Pin 40 als Eingang whlen
			ADMUX = (0<<REFS1) | (0<<REFS0) | (0<<ADLAR) | (0<<MUX4) | (0<<MUX3) | (0<<MUX2) | (0<<MUX1) | (0<<MUX0);
			DDRA &= ~(1<<PA0);
            PORTA &= ~(1<<PA0);
		}
		
		void stop()
		{
			ADCSRA = (0<<ADEN) | (0<<ADSC) | (0<<ADATE) | (0<<ADIF) | (0<<ADIE) | (0<<ADPS2) | (0<<ADPS1) | (0<<ADPS0);
            PORTA |= 0b00000001; //Pullup wieder setzen
		}

        void aktualisieren()
        {
            akku=ADCL;
		    wert=ADCH;
			wert=(wert<<8)+akku;
            ringspeicher[index]=wert;
            index++;
            index%=RINGMAX;
        }        

		int16_t holeAbstand_mm()
		{
            wert=0;
            for(akku=0;akku<RINGMAX;akku++)
                wert+=ringspeicher[akku];
            wert/=RINGMAX;

            if(wert>360)
                return 0;
            else if(wert>248)
                return -wert/6+153;
            else if(wert>40)
                return -wert+360;
            else
                return 320;

        }
};
