//#############################
//# TESTPROGRAMM fr COACH2.2 #
//#############################
//Vor dem Start serielle Verbindung herstellen und 
//ein Hyperterminal mit 115200Baud, 8 Datenbits und einem Stop-Bit ffnen.
//Das Programm auf dem Vehikel kommuniziert mit dem Benutzer ber das Hyperterminal.

//Hier wird der Antrieb getestet.
//Folgen Sie den Anweisungen am Hyperterminal.

#include <avr/io.h>

#include "CoachBASIS.h"
#include "Coach.h"

#include "AnzeigeBASIS.h"
#include "Anzeige.h"

#include "TasterBASIS.h"
#include "Taster.h"

#include "RS232BASIS.h"
#include "RS232.h"

#include "MotorServoBASIS.h"
#include "MotorServo.h"

#include "DrehgeberBASIS.h"
#include "Drehgeber.h"

#include "ZyklusBASIS.h"
#include "Zyklus.h"

#include "SensorBASIS.h"
#include "Sensor.h"

#include "FunkBASIS.h"
#include "Funk.h"


Coach        coach;
Anzeige      anzeige;
Taster       taster;
RS232        rs232;
MotorServo   motorservo;
Drehgeber    drehgeber;
Zyklus       zyklus;
Sensor       sensor;
Funk         funk;

class Befehle
{
    private:
        unsigned long pause;
    public:
        void tudies()
        {
            rs232.sendeText("Tue dies.\n\r");
            funk.sendeText("Tue dies.");
            for(pause=0;pause<50000;pause++);
        }    
        void tudas()
        {
            rs232.sendeText("Tue das.\n\r");
            funk.sendeText("Tue das.");
            for(pause=0;pause<50000;pause++);
        }    
        void tujenes()
        {
            rs232.sendeText("Tue jenes.\n\r");
            funk.sendeText("Tue jenes.");
            for(pause=0;pause<50000;pause++);
        }    
};

int main(void)
{
    unsigned long pause;
    int ii,kk;
    char* text;

    Befehle befehle;
    void (Befehle::*zeiger[3])(void) = {
                                         &Befehle::tudies,  
                                         &Befehle::tudas,
                                         &Befehle::tujenes,
                                       };    

    coach.start();
    anzeige.start();
    taster.start();
    rs232.start();
    motorservo.start();
    drehgeber.start();
    zyklus.start();
    sensor.start();

    funk.start();     // Initialisiere das Funkmodul mit den Einstellungen fr COACH

    rs232.sendeText("\n\rDieses Programm dient dazu, das Funkmodul zu testen.\n\r");

    zyklus.setzeMaxZaehler(50); //50 Zyklen (0..49), bis wieder von vorn gezaehlt wird.


    while(true)
	{
        //Skript empfangen
        text = funk.empfangeText();

        rs232.sendeText("Es wurde folgender Text empfangen:\n\r+++");
        rs232.sendeText(text);
        rs232.sendeText("+++\n\r");
        rs232.sendeText("Dieser wird gleich zurckgesendet.\n\r");

        for(pause=0;pause<5000000;pause++);

        funk.sendeText(text);


        //Skript 10 mal durcharbeiten:
        for(ii=0;ii<10;ii++)
        {
            rs232.sendeText("Durchlauf Nr.");
            rs232.sendeInteger(ii);
            rs232.sendeText("des Skripts:\n\r");
            funk.sendeText("Nchster Durchlauf des Skripts");


            kk=0;
            while(text[kk]!=';')
            {
               (befehle.*(zeiger[text[kk]-65]))();                
               kk++;
            }

            for(pause=0;pause<5000000;pause++);
        }
        funk.sendeText("????????????????");
	}

    sensor.stop();
    zyklus.stop();
    drehgeber.stop();
    motorservo.stop();
    rs232.stop();
    taster.stop();
    anzeige.stop();
    coach.stop();

	return 0;
}
